### Hierarchy

- FilterEffect
  - CompositeEffect

## Index

### Constructors

- constructor

### Properties

- indexBuffer
- indexBufferSize
- mvpMatrix3D
- numLayers
- onRestore
- program
- programBaseName
- programName
- programVariantName
- texture
- textureRepeat
- textureSmoothing
- vertexBuffer
- vertexBufferSize
- vertexFormat
- STD_VERTEX_SHADER
- VERTEX_FORMAT

### Methods

- dispose
- getLayerAt
- get_indexBuffer
- get_indexBufferSize
- get_mvpMatrix3D
- get_numLayers
- get_onRestore
- get_program
- get_programBaseName
- get_programName
- get_programVariantName
- get_texture
- get_textureRepeat
- get_textureSmoothing
- get_vertexBuffer
- get_vertexBufferSize
- get_vertexFormat
- purgeBuffers
- render
- set_mvpMatrix3D
- set_onRestore
- set_programBaseName
- set_texture
- set_textureRepeat
- set_textureSmoothing
- uploadIndexData
- uploadVertexData

## Constructors

### constructor

- new CompositeEffect(numLayers?: number): CompositeEffect

- Overrides FilterEffect.constructor

  - Defined in lib/starling/filters/CompositeFilter.d.ts:56

  #### Parameters

  - ##### Optional numLayers: number

  #### Returns CompositeEffect

## Properties

### Protected indexBuffer

indexBuffer: IndexBuffer3D

Inherited from Effect.indexBuffer

- Defined in lib/starling/rendering/Effect.d.ts:182

The internally used index buffer used on rendering.

### Protected indexBufferSize

indexBufferSize: number

Inherited from Effect.indexBufferSize

- Defined in lib/starling/rendering/Effect.d.ts:186

The current size of the index buffer (in number of indices).

### mvpMatrix3D

mvpMatrix3D: Matrix3D

Inherited from Effect.mvpMatrix3D

- Defined in lib/starling/rendering/Effect.d.ts:177

The MVP (modelview-projection) matrix transforms vertices into clipspace.

### numLayers

numLayers: number

- Defined in lib/starling/filters/CompositeFilter.d.ts:64

### onRestore

onRestore: function

Inherited from Effect.onRestore

- Defined in lib/starling/rendering/Effect.d.ts:167

The that you provide here will be called after a context loss. Call both "upload..." methods from within the callback to restore any vertex or index buffers. The callback will be executed with the effect as its sole parameter.

#### Type declaration

- - (Effect: any): void

  - #### Parameters

    - ##### Effect: any

    #### Returns void

### Protected program

program: Program

Inherited from Effect.program

- Defined in lib/starling/rendering/Effect.d.ts:159

Returns the current program, either by creating a new one (via `createProgram`) or by getting it from the `Painter`. Do not override this method! Instead, implement `createProgram`.

### programBaseName

programBaseName: string

Inherited from Effect.programBaseName

- Defined in lib/starling/rendering/Effect.d.ts:142

Returns the base name for the program. @default the fully qualified class name

### programName

programName: string

Inherited from Effect.programName

- Defined in lib/starling/rendering/Effect.d.ts:153

Returns the full name of the program, which is used to register it at the current `Painter`.

The default implementation efficiently combines the program's base and variant names (e.g. `LightEffect#42`). It shouldn't be necessary to override this method.

### programVariantName

programVariantName: number

Inherited from Effect.programVariantName

- Defined in lib/starling/rendering/Effect.d.ts:136

Override this method if the effect requires a different program depending on the current settings. Ideally, you do this by creating a bit mask encoding all the options. This method is called often, so do not allocate any temporary objects when overriding.

@default 0

### texture

texture: Texture

Inherited from FilterEffect.texture

- Defined in lib/starling/rendering/FilterEffect.d.ts:35

The texture to be mapped onto the vertices.

### textureRepeat

textureRepeat: boolean

Inherited from FilterEffect.textureRepeat

- Defined in lib/starling/rendering/FilterEffect.d.ts:46

Indicates if pixels at the edges will be repeated or clamped. Only works for power-of-two textures. @default false

### textureSmoothing

textureSmoothing: string

Inherited from FilterEffect.textureSmoothing

- Defined in lib/starling/rendering/FilterEffect.d.ts:40

The smoothing filter that is used for the texture. @default bilinear

### Protected vertexBuffer

vertexBuffer: VertexBuffer3D

Inherited from Effect.vertexBuffer

- Defined in lib/starling/rendering/Effect.d.ts:190

The internally used vertex buffer used on rendering.

### Protected vertexBufferSize

vertexBufferSize: number

Inherited from Effect.vertexBufferSize

- Defined in lib/starling/rendering/Effect.d.ts:194

The current size of the vertex buffer (in blocks of 32 bits).

### vertexFormat

vertexFormat: VertexDataFormat

Inherited from Effect.vertexFormat

- Defined in lib/starling/rendering/Effect.d.ts:173

The data format that this effect requires from the VertexData that it renders: `"position:number2"`

### Static STD_VERTEX_SHADER

STD_VERTEX_SHADER: string

Inherited from FilterEffect.STD_VERTEX_SHADER

- Defined in lib/starling/rendering/FilterEffect.d.ts:29

The AGAL code for the standard vertex shader that most filters will use. It simply transforms the vertex coordinates to clip-space and passes the texture coordinates to the fragment program (as 'v0').

### Static VERTEX_FORMAT

VERTEX_FORMAT: VertexDataFormat

Overrides FilterEffect.VERTEX_FORMAT

- Defined in lib/starling/filters/CompositeFilter.d.ts:56

## Methods

### dispose

- dispose(): void

- Inherited from Effect.dispose

  - Defined in lib/starling/rendering/Effect.d.ts:96

  Purges the index- and vertex-buffers.

  #### Returns void

### getLayerAt

- getLayerAt(layerID: number): CompositeLayer

- - Defined in lib/starling/filters/CompositeFilter.d.ts:60

  #### Parameters

  - ##### layerID: number

  #### Returns CompositeLayer

### Protected get_indexBuffer

- get_indexBuffer(): IndexBuffer3D

- Inherited from Effect.get_indexBuffer

  - Defined in lib/starling/rendering/Effect.d.ts:183

  #### Returns IndexBuffer3D

### Protected get_indexBufferSize

- get_indexBufferSize(): number

- Inherited from Effect.get_indexBufferSize

  - Defined in lib/starling/rendering/Effect.d.ts:187

  #### Returns number

### Protected get_mvpMatrix3D

- get_mvpMatrix3D(): Matrix3D

- Inherited from Effect.get_mvpMatrix3D

  - Defined in lib/starling/rendering/Effect.d.ts:178

  #### Returns Matrix3D

### Protected get_numLayers

- get_numLayers(): number

- - Defined in lib/starling/filters/CompositeFilter.d.ts:65

  #### Returns number

### Protected get_onRestore

- get_onRestore(): function

- Inherited from Effect.get_onRestore

  - Defined in lib/starling/rendering/Effect.d.ts:168

  #### Returns function

  - - (Effect: any): void

    - #### Parameters

      - ##### Effect: any

      #### Returns void

### Protected get_program

- get_program(): Program

- Inherited from Effect.get_program

  - Defined in lib/starling/rendering/Effect.d.ts:160

  #### Returns Program

### Protected get_programBaseName

- get_programBaseName(): string

- Inherited from Effect.get_programBaseName

  - Defined in lib/starling/rendering/Effect.d.ts:143

  #### Returns string

### Protected get_programName

- get_programName(): string

- Inherited from Effect.get_programName

  - Defined in lib/starling/rendering/Effect.d.ts:154

  #### Returns string

### Protected get_programVariantName

- get_programVariantName(): number

- Inherited from Effect.get_programVariantName

  - Defined in lib/starling/rendering/Effect.d.ts:137

  #### Returns number

### Protected get_texture

- get_texture(): Texture

- Inherited from FilterEffect.get_texture

  - Defined in lib/starling/rendering/FilterEffect.d.ts:36

  #### Returns Texture

### Protected get_textureRepeat

- get_textureRepeat(): boolean

- Inherited from FilterEffect.get_textureRepeat

  - Defined in lib/starling/rendering/FilterEffect.d.ts:47

  #### Returns boolean

### Protected get_textureSmoothing

- get_textureSmoothing(): string

- Inherited from FilterEffect.get_textureSmoothing

  - Defined in lib/starling/rendering/FilterEffect.d.ts:41

  #### Returns string

### Protected get_vertexBuffer

- get_vertexBuffer(): VertexBuffer3D

- Inherited from Effect.get_vertexBuffer

  - Defined in lib/starling/rendering/Effect.d.ts:191

  #### Returns VertexBuffer3D

### Protected get_vertexBufferSize

- get_vertexBufferSize(): number

- Inherited from Effect.get_vertexBufferSize

  - Defined in lib/starling/rendering/Effect.d.ts:195

  #### Returns number

### Protected get_vertexFormat

- get_vertexFormat(): VertexDataFormat

- Inherited from Effect.get_vertexFormat

  - Defined in lib/starling/rendering/Effect.d.ts:174

  #### Returns VertexDataFormat

### purgeBuffers

- purgeBuffers(vertexBuffer?: boolean, indexBuffer?: boolean): void

- Inherited from Effect.purgeBuffers

  - Defined in lib/starling/rendering/Effect.d.ts:99

  Purges one or both of the vertex- and index-buffers.

  #### Parameters

  - ##### Optional vertexBuffer: boolean

  - ##### Optional indexBuffer: boolean

  #### Returns void

### render

- render(firstIndex?: number, numTriangles?: number): void

- Inherited from Effect.render

  - Defined in lib/starling/rendering/Effect.d.ts:128

  Draws the triangles described by the index- and vertex-buffers, or a range of them. This calls `beforeDraw`, `context.drawTriangles`, and `afterDraw`, in this order.

  #### Parameters

  - ##### Optional firstIndex: number

  - ##### Optional numTriangles: number

  #### Returns void

### Protected set_mvpMatrix3D

- set_mvpMatrix3D(value: Matrix3D): Matrix3D

- Inherited from Effect.set_mvpMatrix3D

  - Defined in lib/starling/rendering/Effect.d.ts:179

  #### Parameters

  - ##### value: Matrix3D

  #### Returns Matrix3D

### Protected set_onRestore

- set_onRestore(value: function): function

- Inherited from Effect.set_onRestore

  - Defined in lib/starling/rendering/Effect.d.ts:169

  #### Parameters

  - ##### value: function

    - - (Effect: any): void

      - #### Parameters

        - ##### Effect: any

        #### Returns void

  #### Returns function

  - - (Effect: any): void

    - #### Parameters

      - ##### Effect: any

      #### Returns void

### Protected set_programBaseName

- set_programBaseName(value: string): string

- Inherited from Effect.set_programBaseName

  - Defined in lib/starling/rendering/Effect.d.ts:144

  #### Parameters

  - ##### value: string

  #### Returns string

### Protected set_texture

- set_texture(value: Texture): Texture

- Overrides FilterEffect.set_texture

  - Defined in lib/starling/filters/CompositeFilter.d.ts:67

  #### Parameters

  - ##### value: Texture

  #### Returns Texture

### Protected set_textureRepeat

- set_textureRepeat(value: boolean): boolean

- Inherited from FilterEffect.set_textureRepeat

  - Defined in lib/starling/rendering/FilterEffect.d.ts:48

  #### Parameters

  - ##### value: boolean

  #### Returns boolean

### Protected set_textureSmoothing

- set_textureSmoothing(value: string): string

- Inherited from FilterEffect.set_textureSmoothing

  - Defined in lib/starling/rendering/FilterEffect.d.ts:42

  #### Parameters

  - ##### value: string

  #### Returns string

### uploadIndexData

- uploadIndexData(indexData: IndexData, bufferUsage?: string): void

- Inherited from Effect.uploadIndexData

  - Defined in lib/starling/rendering/Effect.d.ts:109

  Uploads the given index data to the internal index buffer. If the buffer is too small, a new one is created automatically.

  @param indexData The IndexData instance to upload. @param bufferUsage The expected buffer usage. Use one of the constants defined in `Context3DBufferUsage`. Only used when the method call causes the creation of a new index buffer.

  #### Parameters

  - ##### indexData: IndexData

  - ##### Optional bufferUsage: string

  #### Returns void

### uploadVertexData

- uploadVertexData(vertexData: VertexData, bufferUsage?: string): void

- Inherited from Effect.uploadVertexData

  - Defined in lib/starling/rendering/Effect.d.ts:120

  Uploads the given vertex data to the internal vertex buffer. If the buffer is too small, a new one is created automatically.

  @param vertexData The VertexData instance to upload. @param bufferUsage The expected buffer usage. Use one of the constants defined in `Context3DBufferUsage`. Only used when the method call causes the creation of a new vertex buffer.

  #### Parameters

  - ##### vertexData: VertexData

  - ##### Optional bufferUsage: string

  #### Returns void

Generated using TypeDoc